%define contentdir	/home/httpd

Summary:	The most widely used Web server on the Internet.
Name:		apache
Group:		System Environment/Daemons
License:	Freely distributable and usable
Version:	2.0.54
Release:	6
Source0:	http://www.theshell.com/pub/apache/httpd/httpd-%{version}.tar.bz2
Source1:	httpd.init-gd-2
Source2:	apache.logrotate
Source3:	apache-index.html
Patch00:	apache-2.0.54-EnGarde-Layout-gd-2.diff
Patch01:	apache-2.0.54-openssl-0.9.8-gd-1.diff
Patch02:	apache-2.0.54-httpd.conf-fixes-gd-3.diff
Prereq:		/sbin/chkconfig, /bin/sed, mailcap, grep, textutils,
Prereq:		/usr/sbin/useradd, initscripts >= 5.20, /bin/sh
Requires:	/etc/mime.types, gawk
Provides:	webserver
BuildPrereq:	findutils, perl
BuildRequires:	openssl
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

%description
Apache is a powerful, full-featured, efficient and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

Install the apache package if you need a Web server.

%files
  %defattr(0444,root,root,0555)

  %attr(0500,root,root)		%config %{_sysconfdir}/init.d/httpd
  %attr(0640,root,admin)	%config %{_sysconfdir}/logrotate.d/apache

  %attr(0500,root,root)		%{_sbindir}/ab
  %attr(0500,root,root)		%{_sbindir}/apachectl
  %attr(0500,root,root)		%{_sbindir}/checkgid
  %attr(0500,root,root)		%{_sbindir}/dbmmanage
  %attr(0500,root,root)		%{_sbindir}/envvars
  %attr(0500,root,root)		%{_sbindir}/envvars-std
  %attr(0500,root,root)		%{_sbindir}/htdbm
  %attr(0500,root,root)		%{_sbindir}/htdigest
  %attr(0511,root,root)		%{_sbindir}/htpasswd
  %attr(0500,root,root)		%{_sbindir}/httpd
  %attr(0500,root,root)		%{_sbindir}/logresolve
  %attr(0500,root,root)		%{_sbindir}/rotatelogs

  %attr(0500,root,root)		%{_libexecdir}/apache/*.so
  %attr(0400,root,root)		%{_libexecdir}/apache/httpd.exp
  %attr(0555,root,root)		%{_libdir}/*.so.*

  %attr(0700,webd,root)		%{_sysconfdir}/httpd/modules
  %attr(0750,webd,admin)	%{_sysconfdir}/httpd/logs

  %attr(0640,root,admin)	%{_sysconfdir}/httpd/conf/highperformance-std.conf
  %attr(0640,root,admin)	%{_sysconfdir}/httpd/conf/highperformance.conf
  %attr(0640,root,admin)	%{_sysconfdir}/httpd/conf/httpd-std.conf
  %attr(0640,root,admin)	%config(noreplace) %{_sysconfdir}/httpd/conf/httpd.conf
  %attr(0640,root,admin)	%{_sysconfdir}/httpd/conf/magic
  %attr(0640,root,admin)	%{_sysconfdir}/httpd/conf/mime.types
  %attr(0640,root,admin)	%{_sysconfdir}/httpd/conf/ssl-std.conf
  %attr(0640,root,admin)	%{_sysconfdir}/httpd/conf/ssl.conf

  %dir %attr(750,webd,admin)	%{_var}/log/httpd

  %{_datadir}/apache/error/*
  %{_datadir}/apache/icons/*

  %attr(0444,root,root)		%{contentdir}/html/*

%package devel
Group:		Development/Libraries
Summary:	Development tools for the Apache Web server.

%description devel
The apache-devel package contains the APXS binary and other files that
you'll need to build Dynamic Shared Objects (DSOs) for Apache.

If you are installing the Apache Web server, and you want to be 
able to compile or develop additional modules for Apache, you'll 
need to install this package.

%files devel
  %defattr(0444,root,root,0555)
  %doc %{_mandir}/man?/*

  %attr(0500,root,root)		%{_bindir}/apr-config
  %attr(0500,root,root)		%{_bindir}/apu-config
  %attr(0510,root,admin)	%{_sbindir}/apxs

  %attr(0444,root,root)		%{_libdir}/*.exp
  %attr(0444,root,root)		%{_libdir}/*.a
  %attr(0444,root,root)		%{_libdir}/*.la
  %attr(0555,root,root)		%{_libdir}/*.so

  %{_includedir}/apache
  %{_datadir}/apache/build

%package manual
Summary:	Documentation for the Apache Web server.
Group:		Documentation

%description manual
The apache-manual package contains the complete manual and reference
guide for the Apache Web server.  If you need Apache documentation
installed on the local machine, install this package.  The information
can also be found on the Web at http://www.apache.org/docs/.

%files manual
  %defattr(0444,root,root,0555)
  %{_datadir}/apache/manual

%prep
%setup -q -n httpd-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
  CFLAGS="$RPM_OPT_FLAGS" \
  ./configure --enable-layout=EnGarde \
	--disable-proxy \
	--enable-dav \
	--enable-ssl \
	--enable-vhost-alias \
	--enable-suexec \
	--with-suexec-caller=webd \
	--with-suexec-uidmin=48 \
	--with-suexec-gidmin=48 \
	--enable-mods-shared=all

  make %{?_smp_mflags}

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  make DESTDIR=$RPM_BUILD_ROOT install

  #
  # XXX
  #
  install -d $RPM_BUILD_ROOT%{_sysconfdir}/init.d
  install -d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d

  install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/httpd
  install %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/apache

  # Create appropriate symlinks.
  pushd $RPM_BUILD_ROOT%{_sysconfdir}/httpd/
  ln -sf ../..%{_var}/log/httpd logs
  ln -sf ../..%{_libdir}/apache modules
  popd

  # Install our "default" index.html.
  pushd $RPM_BUILD_ROOT/%{contentdir}
    rm -fr cgi-bin html
    mkdir html
    install %{SOURCE3} html/index.html
  popd

  # Make our log directory.
  install -d $RPM_BUILD_ROOT/%{_var}/log/httpd

%ifarch x86_64
  mkdir $RPM_BUILD_ROOT/%{_libdir}
  mv $RPM_BUILD_ROOT/%{_prefix}/lib/* $RPM_BUILD_ROOT/%{_libdir}
%endif

  # Remove unpackaged files.
  rm -f $RPM_BUILD_ROOT/%{_sbindir}/suexec

%pre
  if [ $1 = 1 ] ; then
	%{_sbindir}/useradd -u 48 -r webd > /dev/null 2>&1 || :
  fi

%post
  if [ -f /var/lock/subsys/httpd ]; then
	%{_sysconfdir}/init.d/httpd restart || 1;
  fi

%preun
  if [ $1 = 0 ]; then
	%{_sysconfdir}/init.d/httpd stop > /dev/null 2>&1
	%{_root_sbindir}/chkconfig --del httpd
  fi

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Wed Sep 7 2005 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.0.54, Release 6
  - ServerTokens Prod (Fixes #0000789).

* Wed Sep 7 2005 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.0.54, Release 5
  - Update the initscript to -DSSL and pass the httpd.conf via -f.
  - Further updates to httpd.conf and ssl.conf, I think we're almost done now.
  - Package an empty /var/log/httpd with the correct permissions.

* Wed Sep 7 2005 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.0.54, Release 4
  - Fix config.layout so a proper httpd.conf is generated.
  - Fix User and Group in httpd-std.conf.in (Fixes #0000785).

* Tue Jul 26 2005 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.0.54, Release 3
  - x86_64 support.

* Fri Jul 08 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.0.54, Release 2
  - Corrected version in previous changelog entry.
  - Rebuild against openssl-0.9.8 and fix the PEM_F_DEF_CALLBACK problem.

* Tue Jun 28 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.0.54, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
